/*
	[WsWndBase.cpp]
	Author : Xing Yanhuan
*/


#include "WsWndBase.h"




// EBhEȒPɈ߂̊NX
// EBhE֘Atꂽ[GWL_USERDATA]𗘗pĂ̂ŁA
//   ̏ꏊłɎȂƂI

WsEasyWndBase::WsEasyWndBase(){
	fWndParam = FALSE;
	hOwnerWnd = NULL;
	hWndParent = NULL;
	hInstance = NULL;
	fCompulsionExit = FALSE;
	fMyBrushBG = false;
	hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
}
// fXgN^
WsEasyWndBase::~WsEasyWndBase(){
	// uV쐬ĂƂ́AjB
	if( fMyBrushBG==true ){
		DeleteObject( hbrBackground );
		fMyBrushBG = false;
	}
}

// ftHgiWǗj̃EBhEvV[WF
// Ɋ֘Atꂽ[GWL_USERDATA]𗘗pāAĂяoNX𔻕ʂ򂷂B
LRESULT CALLBACK WsEasyWndBase::WsEasyWndProcBase(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
	LRESULT lResult;
	WsEasyWndBase* pTargetClass = (WsEasyWndBase*)GetWindowLong( hWnd, GWL_USERDATA );

	// ĂяoNX̃|C^擾s̕␮B
	if (!pTargetClass){
		// CreateWindow()̍ŏI[LPVOID lpParam]ɓnĂ
		// ĂяoNX̃|C^𓾂B
        	if ( (msg==WM_CREATE) || (msg==WM_NCCREATE) ){
			pTargetClass = (WsEasyWndBase*)( (LPCREATESTRUCT)lp )->lpCreateParams;
		}
	}

	// ĂяoNXƂ̐U蕪B
	if( pTargetClass==NULL ){
		lResult = DefWindowProc(hWnd, msg, wp, lp);
	}else{
		lResult = pTargetClass->WndProcVir(hWnd, msg, wp, lp);
	}
	return lResult;
}


// ̃NX̃EBhEEvV[WiftHg番򂵂ČĂяojB
LRESULT CALLBACK WsEasyWndBase::WndProcVir(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp) {
	switch (msg){
	case WM_DESTROY:
		return EasyWnd_Destroy( hWnd, msg, wp, lp );
	case WM_CLOSE:
		return EasyWnd_CLOSE( hWnd, msg, wp, lp );
	case WM_SIZE:
		nWidth = LOWORD( lp );
		nHeight = HIWORD( lp );
//			return EasyWnd_SIZE( hWnd, msg, wp, lp );
	}
	if( 0==IsInnerEventBase(hWnd , msg , wp , lp) ){ return 0; } // NXpB
	if( 0==IsUserEvent(hWnd , msg , wp , lp) ){ return 0; } // [U[̒ǉpB

	return DefWindowProc(hWnd , msg , wp , lp);
}

// I
int WsEasyWndBase::EasyWnd_Destroy( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp ){
	PostQuitMessage(0);
	return 0;
}
// EBhȄIi̕ύXlĂŕʓrĒ`jB
int WsEasyWndBase::EasyWnd_CLOSE( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp ){
	DestroyWindow( hWnd );
	return 0;
}
// pɃNXŒǉ`邽߂Ƀ\bhB
// [`Base]́AႦPaintǉȂ[`Paint]ƏA
//   ̌̌pł͂Ăяo悤ɂ邱ƁB
// Ȃꍇ̕Ԃl[return 1;]Ƃ邱ƁIB
//     ̌ɁA[virtual int IsUserEvent()]Ăяo܂̂ŁB
int WsEasyWndBase::IsInnerEventBase( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
	return 1;
}
// [U[Rɒ`ł郁bZ[W
// 0ԂƁB0ȊOԂƁǍɎ[DefWindowProc()]Ă΂B
int WsEasyWndBase::IsUserEvent( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
	return DefWindowProc(hWnd , msg , wp , lp);
}
// eXgp\bh
//	virtual int WsEasyWndBase::EasyWnd_SIZE( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
//		MessageBox(NULL , TEXT("Kitty on your lap"), TEXT("bZ[W{bNX") , MB_OK);
//	}


// CX^Xnh̃ZbgiK{jB
void WsEasyWndBase::SetInstance( HINSTANCE hInstanceHandle ){ hInstance = hInstanceHandle; }

// CX^XnhԂB
HINSTANCE WsEasyWndBase::GetInstance(){ return (HINSTANCE)hInstance; }


// p[^ZbgẴEBhE쐬B
bool WsEasyWndBase::CreateWnd( HWND hWndParentPre, TCHAR* pWndClassPre, TCHAR* pTitlePre, TCHAR* pMenuPre, TCHAR* pIconPre, int nW, int nH, DWORD dwWndStyle ){
	bool r;
	r = SetWndParam( pWndClassPre, pTitlePre, pMenuPre, pIconPre, nW, nH, dwWndStyle );
	if( r==TRUE ){
		return CreateWnd( hWndParentPre );
	}else{
		return FALSE;
	}
}

// Zbgς݃p[^gẴEBhE쐬B
bool WsEasyWndBase::CreateWnd( HWND hWndParentPre ){
	if( fWndParam==FALSE ){ return FALSE; }

	hOwnerWnd = CreateWindow(
			pWndClassName, pTitleName,
			dwWndStyle ,
			CW_USEDEFAULT , CW_USEDEFAULT ,
			nWidth , nHeight ,
			hWndParentPre , NULL , hInstance , (LPVOID)this
	);

	if (hOwnerWnd == NULL){
		return FALSE;
	}else{
		SetWindowLong( hOwnerWnd, GWL_USERDATA, (long)this );
		hWndParent = hWndParentPre;
		return TRUE;
	}
}

// EChEp[^̃Zbgi쐬͂ȂjB
bool WsEasyWndBase::SetWndParam( TCHAR* pWndClassPre, TCHAR* pTitlePre, TCHAR* pMenuPre, TCHAR* pIconPre, int nW, int nH, DWORD dwWndStylePre ){
	TCHAR* pWndClass;
	TCHAR* pTitle;
	TCHAR* pMenu;
	TCHAR* pIcon;

	if( pWndClassPre==NULL ){ lstrcpy( pWndClassName, TEXT("WsEasyWndBase") ); }
	else{
		lstrcpy( pWndClassName, pWndClassPre );
	}
	pWndClass = pWndClassName;

	if( pTitlePre==NULL ){ lstrcpy( pTitleName, TEXT("G[") ); }
	else{
		lstrcpy( pTitleName, pTitlePre );
	}
	pTitle = pTitleName;

	if( pMenuPre==NULL ){ pMenu = NULL; }
	else{
		lstrcpy( pMenuName, pMenuPre );
		pMenu = pMenuName;
	}

	if( pIconPre==NULL ){ pIcon = NULL; }
	else{
		lstrcpy( pIconName, pIconPre );
		pIcon = pIconName;
	}

	if( nW==NULL ){ nWidth = CW_USEDEFAULT; }
	else{ nWidth = nW; }
	if( nH==NULL ){ nHeight = CW_USEDEFAULT; }
	else{ nHeight = nH; }

	if( dwWndStylePre==NULL ){ dwWndStyle = (WS_OVERLAPPEDWINDOW | WS_VISIBLE); }
	else{ dwWndStyle = dwWndStylePre; }

	winc.style 		= CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc	= WsEasyWndProcBase;
	winc.cbClsExtra	= winc.cbWndExtra	= 0;
	winc.hInstance		= hInstance;
	winc.hIcon		= LoadIcon( hInstance, pIcon );	
	winc.hCursor		= LoadCursor( NULL, IDC_ARROW );
	winc.hbrBackground	= hbrBackground;
	winc.lpszMenuName	= pMenu;
	winc.lpszClassName	= pWndClass;

	// o^̐Szor͖ȂBȂȂ瓯NX𕡐Ăяoꍇɂ́A
	// o^ɂ͎sĂA͍쐬AB
	// ݂ȂƂ́A쐬ŃG[邩AŔfB
	RegisterClass(&winc);
	fWndParam = TRUE;
	return TRUE;
	/*
	if ( !RegisterClass(&winc) ){
		return FALSE;
	}else{
		fWndParam = TRUE;
		return TRUE;
	}
	*/
}

// EBhEnhԂ
HWND WsEasyWndBase::GetWindowHandle(){ return hOwnerWnd; }
// eEBhẼnhԂB
HWND WsEasyWndBase::GetParentWindowHandle(){ return hWndParent; }
// EBhẼ^Cgւ̃|C^ԂB
TCHAR* WsEasyWndBase::GetWindowTitle(){ return pTitleName; }


// EBh̉ԂB
int WsEasyWndBase::GetWndWidth(){ return nWidth; }
// EBh̏cԂB
int WsEasyWndBase::GetWndHeight(){ return nHeight; }

// bZ[W[vIB
// gL邩˂H
void WsEasyWndBase::ExitMessageLoop(){ fCompulsionExit = TRUE; }

// bZ[W[v
int WsEasyWndBase::MessageLoop(){
	while ( GetMessage(&msg , NULL , 0 , 0 ) ) {
		if( IsDialogMessage(hOwnerWnd, &msg) ){ continue; }
		if( fCompulsionExit==TRUE ){ break; }
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	fCompulsionExit = FALSE;
	hOwnerWnd = NULL; //jς݂L
	return msg.wParam;
}

// `ς݂̃uVwiFIB
bool WsEasyWndBase::SetBockGroundColorStock( int nStockBrush ){
	// BLACK_BRUSH  : ̃uV
	// DKGRAY_BRUSH :ZDF̃uV
	// GRAY_BRUSH   :DF̃uV
	// HOLLOW_BRUSH :̃uV (NULL_BRUSH Ɠ)
	// LTGRAY_BRUSH :邢DF̃uV
	// NULL_BRUSH   :̃uV (HOLLOW_BRUSH Ɠ)
	// WHITE_BRUSH  :̃uVftHgłB
	bool fStock = false;

	// łɃEBhE쐬ς݁imɂ́ANXo^ς݁j̏ꍇ͎s܂B
	if( hOwnerWnd!=NULL ){
		return false;
	}

	// w肳ꂽ萔̐`FbN
	switch( nStockBrush ){
		case BLACK_BRUSH:
			fStock = true;
			break;
		case DKGRAY_BRUSH:
			fStock = true;
			break;
		case GRAY_BRUSH:
			fStock = true;
			break;
		case HOLLOW_BRUSH: // =NULL_BRUSH
			fStock = true;
			break;
		case LTGRAY_BRUSH:
			fStock = true;
			break;
		case WHITE_BRUSH:
			fStock = true;
			break;
		default:
			return FALSE;
	}

	// uVɂȂÂ̂jA̎|LB
	if( fMyBrushBG==true ){
		DeleteObject( hbrBackground );
		fMyBrushBG = false;
	}

	// wiFݒB
	hbrBackground = (HBRUSH)GetStockObject( nStockBrush );
	return fStock;
}

// J[R[hwiFIB
bool WsEasyWndBase::SetBockGroundColorCode( COLORREF crColor ){
	HBRUSH hbr;

	// łɃEBhE쐬ς݁imɂ́ANXo^ς݁j̏ꍇ͎s܂B
	if( hOwnerWnd!=NULL ){
		return false;
	}

	hbr = (HBRUSH)CreateSolidBrush( crColor );
	if( hbr==NULL ){ return FALSE; }

	// uVɂȂÂ̂jBłȂȂAVK쐬̎|LB
	if( fMyBrushBG==true ){
		DeleteObject( hbrBackground );
	}else{
		fMyBrushBG = true;
	}

	// wiFݒB
	hbrBackground = hbr;

	return TRUE;
}
// J[R[hiRGBwjwiFIB
bool WsEasyWndBase::SetBockGroundColorRGB( BYTE bRed , BYTE bGreen , BYTE bBlue ){
	return SetBockGroundColorCode( RGB( bRed, bGreen, bBlue ) );
}





