@echo off
setlocal
set CplgiN=TTL_PluginOnC
set CfilE=TTL_Plugin_Main
set CInterfacE=TTL_Plugin_Dll_IF
set Cdebug_filE=DebugMain
set DebugFrag=0
set CompileR=bcc32
if /i "%1"=="help" goto HELP
if /i "%1"=="/help" goto HELP
if /i "%1"=="/?" goto HELP
if /i "%1"=="bcc32" set CompileR=bcc32
if /i "%1"=="cl2010" set CompileR=cl2010
if /i "%1"=="vc2010" set CompileR=cl2010
if not "%2"=="" shift
if /i "%1"=="clean" goto CLEAN
if /i "%1"=="debug" set DebugFrag=1



if exist ..\Lib\%CInterfacE%.obj goto OBJ_OK
pushd ..\Lib
if "%CompileR%"=="bcc32" (
	echo.
	echo bcc32 -w-par -c %CInterfacE%.cpp
	bcc32 -w-par -c %CInterfacE%.cpp
	set LastErr=%errorlevel%
) else (
	echo.
	echo cl /c %CInterfacE%.cpp /Fo%CInterfacE%.obj
	cl /c %CInterfacE%.cpp /Fo%CInterfacE%.obj
	set LastErr=%errorlevel%
)
popd
if not %LastErr%==0 goto END
echo --- 肽ԃ vOCI/F̃RpCOK. ---
echo.
echo.
:OBJ_OK


if %DebugFrag%==1 goto EMULATE


echo.
echo vOC @\̃RpC with RpCςI/F
echo.
if "%CompileR%"=="bcc32" (
	echo bcc32 -w-par -WD %CfilE%.cpp ..\Lib\%CInterfacE%.obj
	bcc32 -w-par -WD %CfilE%.cpp ..\Lib\%CInterfacE%.obj
	set LastErr=%errorlevel%
) else (
	echo.
	echo cl /LD /EHsc %CfilE%.cpp ..\Lib\%CInterfacE%.obj ..\Include\%CfilE%.def /link user32.lib
	cl /LD /EHsc %CfilE%.cpp ..\Lib\%CInterfacE%.obj ..\Include\%CfilE%.def /link user32.lib
	set LastErr=%errorlevel%
)
if not %LastErr%==0 goto END
echo --- vOC @\̃RpCOK. ---
echo.
echo.

if "%CompileR%"=="bcc32" (
	echo.
	echo --- vOC I/F ̃`FbN ------------
	echo impdef %CfilE%.def %CfilE%.dll
	impdef %CfilE%.def %CfilE%.dll
	if not %errorlevel%==0 goto END
	more %CfilE%.def
	echo ------------------------------------------
	echo.
	echo.
	echo Cu[libt@C]쐬
	echo implib %CfilE%.lib %CfilE%.dll
	implib %CfilE%.lib %CfilE%.dll
	if not %errorlevel%==0 goto END
	echo.
) else (
	echo.
	echo --- vOC I/F ̃`FbN ------------
	echo dumpbin /exports %CfilE%.dll
	dumpbin /exports %CfilE%.dll > %CfilE%.dump.log
	more %CfilE%.dump.log
	find " TtlPlgIn_GetTMenuTitle" %CfilE%.dump.log > NUL
	set LastErr=%errorlevel%
	del %CfilE%.dump.log > NUL
	echo ------------------------------------------
	if not %LastErr%==0 goto END
	echo.
)


echo.
echo.
echo 肽ԃ vOC `փl[܂B
del %CplgiN%.tpi >NUL 2>NUL
echo %CfilE%.dll  %CplgiN%.tpi
ren %CfilE%.dll %CplgiN%.tpi
if not %errorlevel%==0 goto END

if NOT EXIST .\Release goto NON_VC_RELEASE
move /Y %CplgiN%.tpi .\Release\
move /Y *.exp .\Release\
move /Y *.lib .\Release\
move /Y *.obj .\Release\
:NON_VC_RELEASE

echo.
echo RpCɐ܂
echo.
goto END





REM --------------------------------------------------------
:EMULATE
echo.
echo vOC @\̃RpC with RpCςI/F
echo.
if "%CompileR%"=="bcc32" (
	echo bcc32 -w-par %Cdebug_filE%.cpp ..\Lib\%CInterfacE%.obj
	bcc32 -w-par %Cdebug_filE%.cpp ..\Lib\%CInterfacE%.obj
	set LastErr=%errorlevel%
) else (
	echo cl /EHsc %Cdebug_filE%.cpp ..\Lib\%CInterfacE%.obj /link user32.lib
	cl /EHsc %Cdebug_filE%.cpp ..\Lib\%CInterfacE%.obj /link user32.lib shell32.lib
	set LastErr=%errorlevel%
)
if not %LastErr%==0 goto END

if NOT EXIST .\Debug goto NON_VC_DEBUG
move /Y %Cdebug_filE%.exe .\Debug\
move /Y %Cdebug_filE%.exp .\Debug\
move /Y %Cdebug_filE%.lib .\Debug\
move /Y %Cdebug_filE%.obj .\Debug\
:NON_VC_DEBUG

echo --- vOC @\̃RpCOK. ---
echo.
echo.
echo.
echo RpCɐ܂
echo.
echo fobOspt@C %Cdebug_filE%.exe 쐬܂B
echo.
goto END





REM --------------------------------------------------------
:HELP
echo.
echo   make bcc32         bcc32 păvOC[*.tpi]쐬B
echo   make cl2010        cl păvOC[*.tpi]쐬B
echo   make vc2010        cl păvOC[*.tpi]쐬B
echo.
echo   make bcc32 debug   bcc32 păfobOst@C[*.exe]쐬B
echo   make cl2010 debug  cl păfobOst@C[*.exe]쐬B
echo   make vc2010 debug  cl păfobOst@C[*.exe]쐬B
echo.
echo   make clean         vOC[*.tpi]ȊO̐t@C폜B
echo.
echo                                              Ver.2010.11.06
echo.
goto END



REM --------------------------------------------------------
:CLEAN
echo.
echo del *.def
del *.def >NUL 2>NUL

echo del *.exp
del *.exp >NUL 2>NUL
if EXIST .\Debug del Debug\*.exp >NUL 2>NUL
if EXIST .\Release del Release\*.exp >NUL 2>NUL

echo del *.lib
del *.lib >NUL 2>NUL
if EXIST .\Debug del Debug\*.lib >NUL 2>NUL
if EXIST .\Release del Release\*.lib >NUL 2>NUL

echo del *.obj
del *.obj >NUL 2>NUL
del ..\Lib\*.obj >NUL 2>NUL
if EXIST .\Debug del Debug\*.obj >NUL 2>NUL
if EXIST .\Release del Release\*.obj >NUL 2>NUL

echo del *.exe
del *.exe >NUL 2>NUL
if EXIST .\Debug del Debug\*.exe >NUL 2>NUL
if EXIST .\Release del Release\*.exe >NUL 2>NUL

echo del *.tds
del *.tds >NUL 2>NUL

echo del *.tds
del *.tds >NUL 2>NUL

if NOT EXIST .\NoteOut goto NON_NOTEOUT
echo del NoteOut\*.html
del NoteOut\*.html >NUL 2>NUL
:NON_NOTEOUT



:END
if not %errorlevel%==0 pause
endlocal
